#include "driver.h"

extern struct MachineDriver pacman_driver;
extern struct MachineDriver mspacman_driver;
extern struct MachineDriver crush_driver;
extern struct MachineDriver pengo_driver;
extern struct MachineDriver ladybug_driver;
extern struct MachineDriver mrdo_driver;
extern struct MachineDriver cclimber_driver;
extern struct MachineDriver ckong_driver;
extern struct MachineDriver dkong_driver;
extern struct MachineDriver dkongjr_driver;
extern struct MachineDriver bagman_driver;
extern struct MachineDriver wow_driver;
extern struct MachineDriver galaxian_driver;
extern struct MachineDriver pisces_driver;
extern struct MachineDriver japirem_driver;
extern struct MachineDriver warofbug_driver;
extern struct MachineDriver mooncrst_driver;
extern struct MachineDriver moonqsr_driver;
extern struct MachineDriver theend_driver;
extern struct MachineDriver frogger_driver;
extern struct MachineDriver scramble_driver;
extern struct MachineDriver atlantis_driver;
extern struct MachineDriver scobra_driver;
extern struct MachineDriver amidar_driver;
extern struct MachineDriver turtles_driver;
extern struct MachineDriver rallyx_driver;
extern struct MachineDriver pooyan_driver;
extern struct MachineDriver phoenix_driver;
extern struct MachineDriver carnival_driver;
extern struct MachineDriver invaders_driver;
extern struct MachineDriver mario_driver;
extern struct MachineDriver zaxxon_driver;
extern struct MachineDriver bombjack_driver;



ROM_START( pacman_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "%s.6e", 0x0000, 0x1000 )
	ROM_LOAD( "%s.6f", 0x1000, 0x1000 )
	ROM_LOAD( "%s.6h", 0x2000, 0x1000 )
	ROM_LOAD( "%s.6j", 0x3000, 0x1000 )

	ROM_REGION(0x2000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "%s.5e", 0x0000, 0x1000 )
	ROM_LOAD( "%s.5f", 0x1000, 0x1000 )
ROM_END



ROM_START( pacmod_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "6e.mod",    0x0000, 0x1000 )
	ROM_LOAD( "pacman.6f", 0x1000, 0x1000 )
	ROM_LOAD( "6h.mod",    0x2000, 0x1000 )
	ROM_LOAD( "pacman.6j", 0x3000, 0x1000 )

	ROM_REGION(0x2000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "5e",        0x0000, 0x1000 )
	ROM_LOAD( "5f",        0x1000, 0x1000 )
ROM_END



ROM_START( piranha_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "pr1.cpu", 0x0000, 0x1000 )
	ROM_LOAD( "pr2.cpu", 0x1000, 0x1000 )
	ROM_LOAD( "pr3.cpu", 0x2000, 0x1000 )
	ROM_LOAD( "pr4.cpu", 0x3000, 0x1000 )

	ROM_REGION(0x2000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "pr5.cpu", 0x0000, 0x0800 )
	ROM_LOAD( "pr7.cpu", 0x0800, 0x0800 )
	ROM_LOAD( "pr6.cpu", 0x1000, 0x0800 )
	ROM_LOAD( "pr8.cpu", 0x1800, 0x0800 )
ROM_END



ROM_START( mspacman_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "boot1", 0x0000, 0x1000 )
	ROM_LOAD( "boot2", 0x1000, 0x1000 )
	ROM_LOAD( "boot3", 0x2000, 0x1000 )
	ROM_LOAD( "boot4", 0x3000, 0x1000 )
	ROM_LOAD( "boot5", 0x8000, 0x1000 )
	ROM_LOAD( "boot6", 0x9000, 0x1000 )

	ROM_REGION(0x2000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "5e",    0x0000, 0x1000 )
	ROM_LOAD( "5f",    0x1000, 0x1000 )
ROM_END



ROM_START( crush_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "CR1", 0x0000, 0x0800 )
	ROM_LOAD( "CR5", 0x0800, 0x0800 )
	ROM_LOAD( "CR2", 0x1000, 0x0800 )
	ROM_LOAD( "CR6", 0x1800, 0x0800 )
	ROM_LOAD( "CR3", 0x2000, 0x0800 )
	ROM_LOAD( "CR7", 0x2800, 0x0800 )
	ROM_LOAD( "CR4", 0x3000, 0x0800 )
	ROM_LOAD( "CR8", 0x3800, 0x0800 )

	ROM_REGION(0x2000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "CRA", 0x0000, 0x0800 )
	ROM_LOAD( "CRC", 0x0800, 0x0800 )
	ROM_LOAD( "CRB", 0x1000, 0x0800 )
	ROM_LOAD( "CRD", 0x1800, 0x0800 )
ROM_END



ROM_START( pengo_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "pengopop.u8",  0x0000, 0x1000 )
	ROM_LOAD( "pengopop.u7",  0x1000, 0x1000 )
	ROM_LOAD( "pengopop.u15", 0x2000, 0x1000 )
	ROM_LOAD( "pengopop.u14", 0x3000, 0x1000 )
	ROM_LOAD( "pengopop.u21", 0x4000, 0x1000 )
	ROM_LOAD( "pengopop.u20", 0x5000, 0x1000 )
	ROM_LOAD( "pengopop.u32", 0x6000, 0x1000 )
	ROM_LOAD( "pengopop.u31", 0x7000, 0x1000 )

	ROM_REGION(0x4000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "pengopop.u92", 0x0000, 0x2000 )
	ROM_LOAD( "pengopop.105", 0x2000, 0x2000 )
ROM_END



ROM_START( penta_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "penta.u8",  0x0000, 0x1000 )
	ROM_LOAD( "penta.u7",  0x1000, 0x1000 )
	ROM_LOAD( "penta.u15", 0x2000, 0x1000 )
	ROM_LOAD( "penta.u14", 0x3000, 0x1000 )
	ROM_LOAD( "penta.u21", 0x4000, 0x1000 )
	ROM_LOAD( "penta.u20", 0x5000, 0x1000 )
	ROM_LOAD( "penta.u32", 0x6000, 0x1000 )
	ROM_LOAD( "penta.u31", 0x7000, 0x1000 )

	ROM_REGION(0x4000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "penta.u92", 0x0000, 0x2000 )
	ROM_LOAD( "penta.105", 0x2000, 0x2000 )
ROM_END



ROM_START( ladybug_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "lb1.cpu",  0x0000, 0x1000 )
	ROM_LOAD( "lb2.cpu",  0x1000, 0x1000 )
	ROM_LOAD( "lb3.cpu",  0x2000, 0x1000 )
	ROM_LOAD( "lb4.cpu",  0x3000, 0x1000 )
	ROM_LOAD( "lb5.cpu",  0x4000, 0x1000 )
	ROM_LOAD( "lb6.cpu",  0x5000, 0x1000 )

	ROM_REGION(0x4000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "lb9.vid",  0x0000, 0x1000 )
	ROM_LOAD( "lb10.vid", 0x1000, 0x1000 )
	ROM_LOAD( "lb8.cpu",  0x2000, 0x1000 )
	ROM_LOAD( "lb7.cpu",  0x3000, 0x1000 )
ROM_END



ROM_START( mrdo_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "D1",  0x0000, 0x2000 )
	ROM_LOAD( "D2",  0x2000, 0x2000 )
	ROM_LOAD( "D3",  0x4000, 0x2000 )
	ROM_LOAD( "D4",  0x6000, 0x2000 )

	ROM_REGION(0x6000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "D9",  0x0000, 0x1000 )
	ROM_LOAD( "D10", 0x1000, 0x1000 )
	ROM_LOAD( "D8",  0x2000, 0x1000 )
	ROM_LOAD( "D7",  0x3000, 0x1000 )
	ROM_LOAD( "D5",  0x4000, 0x1000 )
	ROM_LOAD( "D6",  0x5000, 0x1000 )
ROM_END



ROM_START( mrlo_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "a4-01.bin", 0x0000, 0x2000 )
	ROM_LOAD( "c4-02.bin", 0x2000, 0x2000 )
	ROM_LOAD( "e4-03.bin", 0x4000, 0x2000 )
	ROM_LOAD( "g4-04.bin", 0x6000, 0x2000 )

	ROM_REGION(0x6000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "s8-09.bin", 0x0000, 0x1000 )
	ROM_LOAD( "u8-10.bin", 0x1000, 0x1000 )
	ROM_LOAD( "r8-08.bin", 0x2000, 0x1000 )
	ROM_LOAD( "n8-07.bin", 0x3000, 0x1000 )
	ROM_LOAD( "h5-05.bin", 0x4000, 0x1000 )
	ROM_LOAD( "k5-06.bin", 0x5000, 0x1000 )
ROM_END



ROM_START( cclimber_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "cc11", 0x0000, 0x1000 )
	ROM_LOAD( "cc10", 0x1000, 0x1000 )
	ROM_LOAD( "cc09", 0x2000, 0x1000 )
	ROM_LOAD( "cc08", 0x3000, 0x1000 )
	ROM_LOAD( "cc07", 0x4000, 0x1000 )

	ROM_REGION(0x3000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "cc06", 0x0000, 0x0800 )
	ROM_LOAD( "cc04", 0x0800, 0x0800 )
	ROM_LOAD( "cc05", 0x1000, 0x0800 )
	ROM_LOAD( "cc03", 0x1800, 0x0800 )
	ROM_LOAD( "cc02", 0x2000, 0x0800 )
	ROM_LOAD( "cc01", 0x2800, 0x0800 )

	ROM_REGION(0x2000)	/* samples */
	ROM_LOAD( "cc13", 0x0000, 0x1000 )
	ROM_LOAD( "cc12", 0x1000, 0x1000 )
ROM_END



unsigned cclimber_decode(dword A)
{
	static const unsigned char evetab[] =
	{
		0x44,0x14,0x47,0x12,0x54,0x10,0x13,0x46,0x4c,0x1c,0x4f,0x1a,0x5c,0x18,0x1b,0x4e,
		0x11,0x41,0x07,0x52,0x05,0x50,0x53,0x06,0x19,  -1,0x0f,0x5a,0x0d,0x58,0x5b,0x0e,
		0x64,0x34,0x67,0x32,0x74,0x30,0x33,0x66,0x6c,0x3c,0x6f,0x3a,0x7c,0x38,0x3b,0x6e,
		0x31,  -1,0x27,0x72,0x25,0x70,0x73,0x26,0x39,  -1,0x2f,0x7a,0x2d,0x78,0x7b,0x2e,
		0x51,0x00,0x43,0x16,0x40,0x55,0x17,0x42,0x59,0x08,0x4b,0x1e,0x48,0x5d,0x1f,0x4a,
		  -1,0x04,0x03,0x56,0x01,0x15,0x57,0x02,  -1,  -1,0x0b,0x5e,0x09,0x1d,0x5f,0x0a,
		0x71,0x20,0x63,0x36,0x60,0x75,0x37,0x62,0x79,0x28,0x6b,0x3e,0x68,0x7d,0x3f,0x6a,
		  -1,  -1,0x23,0x76,0x21,0x35,0x77,0x22,  -1,  -1,0x2b,0x7e,0x29,0x3d,0x7f,0x2a,
		0xd4,0xd1,0xd3,0x86,0x95,0xc5,0x92,  -1,0xdc,0xd9,0xdb,  -1,0x9d,0xcd,0x9a,  -1,
		0xc4,0x81,0xd2,0xc2,0x91,0xc1,0x82,  -1,0xcc,  -1,0xda,0xca,0x99,0xc9,0x8a,  -1,
		0xf4,0xf1,0xf3,  -1,0xb5,0xe5,0xb2,  -1,0xfc,0xf9,0xfb,  -1,0xbd,0xed,0xba,  -1,
		0xe4,  -1,0xf2,0xe2,0xb1,0xe1,0xa2,  -1,0xec,  -1,0xfa,0xea,0xb9,0xe9,0xaa,  -1,
		0x84,0xd5,0xc3,0x83,0xd0,  -1,0x87,0x97,0x8c,0xdd,0xcb,  -1,0xd8,  -1,0x8f,0x9f,
		0x80,0x90,0x93,0x96,0xc0,  -1,0xc6,0xd6,0x88,0x98,0x9b,0x9e,0xc8,  -1,0xce,0xde,
		0xa4,0xf5,0xe3,  -1,0xf0,  -1,0xa7,0xb7,0xac,0xfd,0xeb,  -1,0xf8,  -1,0xaf,0xbf,
		0xa0,0xb0,0xb3,0xb6,0xe0,  -1,0xe6,0xf6,0xa8,0xb8,0xbb,0xbe,0xe8,  -1,0xee,0xfe
	};
	static const unsigned char oddtab[] =
	{
		0x44,0x10,0x06,0x53,0x15,0x55,0x47,0x02,0x4c,0x18,0x0e,0x5b,0x1d,0x5d,0x4f,0x0a,
		0x00,0x41,0x46,0x12,  -1,0x51,  -1,0x57,0x08,  -1,0x4e,0x1a,  -1,0x59,  -1,0x5f,
		0x64,0x30,0x26,0x73,0x35,0x75,0x67,0x22,0x6c,0x38,0x2e,0x7b,0x3d,0x7d,0x6f,0x2a,
		0x20,  -1,0x66,0x32,  -1,0x71,  -1,0x77,0x28,  -1,0x6e,0x3a,  -1,0x79,  -1,0x7f,
		0x14,0x45,0x13,0x56,0x11,0x50,0x52,0x42,0x1c,0x4d,0x1b,0x5e,0x19,0x58,0x5a,  -1,
		0x01,0x54,0x07,  -1,0x04,0x05,0x16,0x03,0x09,0x5c,0x0f,  -1,0x0c,0x0d,0x1e,0x0b,
		0x34,0x65,0x33,0x76,0x31,0x70,0x72,  -1,0x3c,0x6d,0x3b,0x7e,0x39,0x78,0x7a,  -1,
		0x21,0x74,0x27,  -1,0x24,0x25,0x36,0x23,0x29,0x7c,0x2f,  -1,0x2c,0x2d,0x3e,0x2b,
		  -1,  -1,  -1,  -1,  -1,  -1,0xd6,0x83,  -1,0xdc,  -1,  -1,  -1,0xd8,0xde,  -1,
		0xd1,0x81,0x97,0xc2,  -1,0xc0,0xc7,0xc3,0xd9,  -1,0x9f,0xca,  -1,0xc8,  -1,0xcb,
		  -1,  -1,  -1,  -1,0xb4,  -1,0xf6,  -1,  -1,  -1,  -1,  -1,  -1,  -1,0xfe,  -1,
		0xf1,  -1,0xb7,0xe2,  -1,0xe0,  -1,0xe3,0xf9,  -1,0xbf,0xea,  -1,0xe8,  -1,0xeb,
		0xc1,0x90,0xd3,0x86,0x80,0xd5,0xd2,0x87,0xc9,0x98,0xdb,0x8e,  -1,0xdd,0xda,0x8f,
		0x85,0xc4,0x93,0xc6,0x91,0xc5,0x92,0x96,  -1,0xcc,0x9b,0xce,0x99,0xcd,  -1,0x9e,
		0xe1,0xb0,0xf3,0xa6,  -1,0xf5,0xf2,0xa7,0xe9,0xb8,0xfb,0xae,  -1,0xfd,0xfa,0xaf,
		  -1,0xe4,0xb3,0xe6,0xb1,0xe5,  -1,0xb6,  -1,0xec,0xbb,0xee,0xb9,0xed,  -1,0xbe
	};


	if (A & 1) return oddtab[RAM[A]];
	else return evetab[RAM[A]];
}



ROM_START( ccjap_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "cc11j.bin", 0x0000, 0x1000 )
	ROM_LOAD( "cc10j.bin", 0x1000, 0x1000 )
	ROM_LOAD( "cc09j.bin", 0x2000, 0x1000 )
	ROM_LOAD( "cc08j.bin", 0x3000, 0x1000 )
	ROM_LOAD( "cc07j.bin", 0x4000, 0x1000 )

	ROM_REGION(0x3000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "cc06j.bin", 0x0000, 0x0800 )
	ROM_LOAD( "cc04j.bin", 0x0800, 0x0800 )
	ROM_LOAD( "cc05j.bin", 0x1000, 0x0800 )
	ROM_LOAD( "cc03j.bin", 0x1800, 0x0800 )
	ROM_LOAD( "cc02j.bin", 0x2000, 0x0800 )
	ROM_LOAD( "cc01j.bin", 0x2800, 0x0800 )

	ROM_REGION(0x2000)	/* samples */
	ROM_LOAD( "cc13j.bin", 0x0000, 0x1000 )
	ROM_LOAD( "cc12j.bin", 0x1000, 0x1000 )
ROM_END



ROM_START( ccboot_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "m11.bin", 0x0000, 0x1000 )
	ROM_LOAD( "m10.bin", 0x1000, 0x1000 )
	ROM_LOAD( "m09.bin", 0x2000, 0x1000 )
	ROM_LOAD( "m08.bin", 0x3000, 0x1000 )
	ROM_LOAD( "m07.bin", 0x4000, 0x1000 )

	ROM_REGION(0x3000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "m06.bin", 0x0000, 0x0800 )
	ROM_LOAD( "m04.bin", 0x0800, 0x0800 )
	ROM_LOAD( "m05.bin", 0x1000, 0x0800 )
	ROM_LOAD( "m03.bin", 0x1800, 0x0800 )
	ROM_LOAD( "m02.bin", 0x2000, 0x0800 )
	ROM_LOAD( "m01.bin", 0x2800, 0x0800 )

	ROM_REGION(0x2000)	/* samples */
	ROM_LOAD( "m13.bin", 0x0000, 0x1000 )
	ROM_LOAD( "m12.bin", 0x1000, 0x1000 )
ROM_END



unsigned ccjap_decode(dword A)
{
	static const unsigned char evetab[] =
	{
		0x41,0x54,0x46,0x13,0x51,0x14,0x02,0x52,0x49,0x5c,0x4e,0x1b,0x59,0x1c,0x0a,0x5a,
		0x05,0x10,0x43,0x56,0x01,0x55,0x06,0x16,0x0d,0x18,0x4b,0x5e,0x09,0x5d,0x0e,0x1e,
		0x61,0x74,0x66,0x33,0x71,0x34,0x22,0x72,0x69,0x7c,0x6e,0x3b,0x79,0x3c,0x2a,0x7a,
		0x25,0x30,0x63,0x76,0x21,0x75,0x26,0x36,0x2d,0x38,0x6b,0x7e,0x29,0x7d,0x2e,0x3e,
		0x44,0x11,0x17,0x42,0x00,0x50,0x53,0x57,0x4c,0x19,0x1f,0x4a,0x08,0x58,0x5b,0x5f,
		0x15,0x40,0x07,0x12,0x04,0x45,0x03,0x47,0x1d,0x48,0x0f,0x1a,0x0c,0x4d,0x0b,0x4f,
		0x64,0x31,0x37,0x62,0x20,0x70,0x73,0x77,0x6c,0x39,0x3f,0x6a,0x28,0x78,0x7b,0x7f,
		0x35,0x60,0x27,0x32,0x24,0x65,0x23,0x67,0x3d,0x68,0x2f,0x3a,0x2c,0x6d,0x2b,0x6f,
		0x94,0xc1,0x87,0xd7,0x81,0xc4,0x82,0xd2,0x9c,0xc9,0x8f,0xdf,0x89,0xcc,0x8a,0xda,
		0x84,0xd0,0x93,0xc2,0xd1,0xc5,0xd6,0x96,0x8c,0xd8,0x9b,0xca,0xd9,0xcd,0xde,0x9e,
		0xb4,0xe1,0xa7,0xf7,0xa1,0xe4,0xa2,0xf2,0xbc,0xe9,0xaf,0xff,0xa9,0xec,0xaa,0xfa,
		0xa4,0xf0,0xb3,0xe2,0xf1,0xe5,0xf6,0xb6,0xac,0xf8,0xbb,0xea,0xf9,0xed,0xfe,0xbe,
		0x91,0xc0,0xc7,0xd3,0xd4,0x95,0x92,0x86,0x99,0xc8,0xcf,0xdb,0xdc,0x9d,0x9a,0x8e,
		0x90,0x80,0xc6,0x83,0xd5,0x85,0xc3,0x97,0x98,0x88,0xce,0x8b,0xdd,0x8d,0xcb,0x9f,
		0xb1,0xe0,0xe7,0xf3,0xf4,0xb5,0xb2,0xa6,0xb9,0xe8,0xef,0xfb,0xfc,0xbd,0xba,0xae,
		0xb0,0xa0,0xe6,0xa3,0xf5,0xa5,0xe3,0xb7,0xb8,0xa8,0xee,0xab,0xfd,0xad,0xeb,0xbf
	};
	static const unsigned char oddtab[] =
	{
		0x50,0x11,0x12,0x52,0x40,0x55,0x56,0x57,0x58,0x19,0x1a,0x5a,0x48,0x5d,0x5e,0x5f,
		0x51,0x14,0x03,0x46,0x45,0x04,0x42,0x06,0x59,0x1c,0x0b,0x4e,0x4d,0x0c,0x4a,0x0e,
		0x70,0x31,0x32,0x72,0x60,0x75,0x76,0x77,0x78,0x39,0x3a,0x7a,0x68,0x7d,0x7e,0x7f,
		0x71,0x34,0x23,0x66,0x65,0x24,0x62,0x26,0x79,0x3c,0x2b,0x6e,0x6d,0x2c,0x6a,0x2e,
		0x54,0x15,0x16,0x13,0x10,0x05,0x02,0x43,0x5c,0x1d,0x1e,0x1b,0x18,0x0d,0x0a,0x4b,
		0x44,0x01,0x47,0x17,0x00,0x41,0x53,0x07,0x4c,0x09,0x4f,0x1f,0x08,0x49,0x5b,0x0f,
		0x74,0x35,0x36,0x33,0x30,0x25,0x22,0x63,0x7c,0x3d,0x3e,0x3b,0x38,0x2d,0x2a,0x6b,
		0x64,0x21,0x67,0x37,0x20,0x61,0x73,0x27,0x6c,0x29,0x6f,0x3f,0x28,0x69,0x7b,0x2f,
		0x81,0x85,0xd7,0xd2,0xc1,0xc5,0x97,0x92,0x89,0x8d,0xdf,0xda,0xc9,0xcd,0x9f,0x9a,
		0xd4,0xd0,0x83,0x86,0xd5,0x90,0xc3,0xc6,0xdc,0xd8,0x8b,0x8e,0xdd,0x98,0xcb,0xce,
		0xa1,0xa5,0xf7,0xf2,0xe1,0xe5,0xb7,0xb2,0xa9,0xad,0xff,0xfa,0xe9,0xed,0xbf,0xba,
		0xf4,0xf0,0xa3,0xa6,0xf5,0xb0,0xe3,0xe6,0xfc,0xf8,0xab,0xae,0xfd,0xb8,0xeb,0xee,
		0x91,0x95,0xc7,0xc2,0xd1,0x94,0x87,0x82,0x99,0x9d,0xcf,0xca,0xd9,0x9c,0x8f,0x8a,
		0xc4,0xc0,0x93,0x96,0x84,0x80,0xd3,0xd6,0xcc,0xc8,0x9b,0x9e,0x8c,0x88,0xdb,0xde,
		0xb1,0xb5,0xe7,0xe2,0xf1,0xb4,0xa7,0xa2,0xb9,0xbd,0xef,0xea,0xf9,0xbc,0xaf,0xaa,
		0xe4,0xe0,0xb3,0xb6,0xa4,0xa0,0xf3,0xf6,0xec,0xe8,0xbb,0xbe,0xac,0xa8,0xfb,0xfe
	};


	if (A & 1) return oddtab[RAM[A]];
	else return evetab[RAM[A]];
}



ROM_START( ckong_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "7.dat",  0x0000, 0x1000 )
	ROM_LOAD( "8.dat",  0x1000, 0x1000 )
	ROM_LOAD( "9.dat",  0x2000, 0x1000 )
	ROM_LOAD( "10.dat", 0x3000, 0x1000 )
	ROM_LOAD( "11.dat", 0x4000, 0x1000 )
	ROM_LOAD( "12.dat", 0x5000, 0x1000 )

	ROM_REGION(0x5000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "6.dat",  0x0000, 0x1000 )
	ROM_LOAD( "4.dat",  0x1000, 0x1000 )
	ROM_LOAD( "5.dat",  0x2000, 0x1000 )
	ROM_LOAD( "3.dat",  0x3000, 0x1000 )
	ROM_LOAD( "2.dat",  0x4000, 0x0800 )
	ROM_LOAD( "1.dat",  0x4800, 0x0800 )

	ROM_REGION(0x2000)	/* samples */
	ROM_LOAD( "14.dat", 0x0000, 0x1000 )
	ROM_LOAD( "13.dat", 0x1000, 0x1000 )
ROM_END



ROM_START( dkong_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "dk.5e",  0x0000, 0x1000 )
	ROM_LOAD( "dk.5c",  0x1000, 0x1000 )
	ROM_LOAD( "dk.5b",  0x2000, 0x1000 )
	ROM_LOAD( "dk.5a",  0x3000, 0x1000 )

	ROM_REGION(0x3000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "dk.3n",  0x0000, 0x0800 )
	ROM_LOAD( "dk.3p",  0x0800, 0x0800 )
	ROM_LOAD( "dk.7c",  0x1000, 0x0800 )
	ROM_LOAD( "dk.7d",  0x1800, 0x0800 )
	ROM_LOAD( "dk.7e",  0x2000, 0x0800 )
	ROM_LOAD( "dk.7f",  0x2800, 0x0800 )

	ROM_REGION(0x1000)	/* sound? */
	ROM_LOAD( "dk.3h",  0x0000, 0x0800 )
	ROM_LOAD( "dk.3f",  0x0800, 0x0800 )
ROM_END



ROM_START( dkongjr_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "dkj.5b",  0x0000, 0x1000 )
	ROM_CONTINUE(        0x3000, 0x1000 )
	ROM_LOAD( "dkj.5c",  0x2000, 0x0800 )
	ROM_CONTINUE(        0x4800, 0x0800 )
	ROM_CONTINUE(        0x1000, 0x0800 )
	ROM_CONTINUE(        0x5800, 0x0800 )
	ROM_LOAD( "dkj.5e",  0x4000, 0x0800 )
	ROM_CONTINUE(        0x2800, 0x0800 )
	ROM_CONTINUE(        0x5000, 0x0800 )
	ROM_CONTINUE(        0x1800, 0x0800 )

	ROM_REGION(0x4000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "dkj.3n",  0x0000, 0x1000 )
	ROM_LOAD( "dkj.3p",  0x1000, 0x1000 )
	ROM_LOAD( "dkj.7c",  0x2000, 0x0800 )
	ROM_LOAD( "dkj.7d",  0x2800, 0x0800 )
	ROM_LOAD( "dkj.7e",  0x3000, 0x0800 )
	ROM_LOAD( "dkj.7f",  0x3800, 0x0800 )

	ROM_REGION(0x1000)	/* sound? */
	ROM_LOAD( "dkj.3h",  0x0000, 0x1000 )
ROM_END



ROM_START( bagman_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "a4_9e.bin", 0x0000, 0x1000 )
	ROM_LOAD( "a4_9f.bin", 0x1000, 0x1000 )
	ROM_LOAD( "a4_9j.bin", 0x2000, 0x1000 )
	ROM_LOAD( "a4_9k.bin", 0x3000, 0x1000 )
	ROM_LOAD( "a4_9m.bin", 0x4000, 0x1000 )
	ROM_LOAD( "a4_9n.bin", 0x5000, 0x1000 )

	ROM_REGION(0x4000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "a2_1e.bin", 0x0000, 0x1000 )
	ROM_LOAD( "a2_1j.bin", 0x1000, 0x1000 )
	ROM_LOAD( "a2_1c.bin", 0x2000, 0x1000 )
	ROM_LOAD( "a2_1f.bin", 0x3000, 0x1000 )

	ROM_REGION(0x2000)	/* ??? */
	ROM_LOAD( "a1_9r.bin", 0x0000, 0x1000 )
	ROM_LOAD( "a1_9t.bin", 0x1000, 0x1000 )
ROM_END



ROM_START( wow_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "wow.x1", 0x0000, 0x1000 )
	ROM_LOAD( "wow.x2", 0x1000, 0x1000 )
	ROM_LOAD( "wow.x3", 0x2000, 0x1000 )
	ROM_LOAD( "wow.x4", 0x3000, 0x1000 )
	ROM_LOAD( "wow.x5", 0x8000, 0x1000 )
	ROM_LOAD( "wow.x6", 0x9000, 0x1000 )
	ROM_LOAD( "wow.x7", 0xa000, 0x1000 )
/*	ROM_LOAD( "wow.x8", 0xc000, 0x1000 )	here would go the foreign language ROM */
ROM_END



ROM_START( robby_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "robbya", 0x0000, 0x1000 )
	ROM_LOAD( "robbyb", 0x1000, 0x1000 )
	ROM_LOAD( "robbyc", 0x2000, 0x1000 )
	ROM_LOAD( "robbyd", 0x3000, 0x1000 )
	ROM_LOAD( "robbye", 0x8000, 0x1000 )
	ROM_LOAD( "robbyf", 0x9000, 0x1000 )
	ROM_LOAD( "robbyg", 0xa000, 0x1000 )
	ROM_LOAD( "robbyh", 0xb000, 0x1000 )
	ROM_LOAD( "robbyi", 0xc000, 0x1000 )
	ROM_LOAD( "robbyj", 0xd000, 0x1000 )
ROM_END



ROM_START( gorf_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "gorf-a.bin", 0x0000, 0x1000 )
	ROM_LOAD( "gorf-b.bin", 0x1000, 0x1000 )
	ROM_LOAD( "gorf-c.bin", 0x2000, 0x1000 )
	ROM_LOAD( "gorf-d.bin", 0x3000, 0x1000 )
	ROM_LOAD( "gorf-e.bin", 0x8000, 0x1000 )
	ROM_LOAD( "gorf-f.bin", 0x9000, 0x1000 )
	ROM_LOAD( "gorf-g.bin", 0xa000, 0x1000 )
	ROM_LOAD( "gorf-h.bin", 0xb000, 0x1000 )
ROM_END



ROM_START( galaxian_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "%s.u",  0x0000, 0x0800 )
	ROM_LOAD( "%s.v",  0x0800, 0x0800 )
	ROM_LOAD( "%s.w",  0x1000, 0x0800 )
	ROM_LOAD( "%s.y",  0x1800, 0x0800 )
	ROM_LOAD( "%s.z",  0x2000, 0x0800 )

	ROM_REGION(0x1000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "%s.1j", 0x0000, 0x0800 )
	ROM_LOAD( "%s.1k", 0x0800, 0x0800 )
ROM_END



ROM_START( galnamco_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "galaxian.u",  0x0000, 0x0800 )
	ROM_LOAD( "galaxian.v",  0x0800, 0x0800 )
	ROM_LOAD( "galaxian.w",  0x1000, 0x0800 )
	ROM_LOAD( "galaxian.y",  0x1800, 0x0800 )
	ROM_LOAD( "galaxian.z",  0x2000, 0x0800 )

	ROM_REGION(0x1000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "galaxian.1h", 0x0000, 0x0800 )
	ROM_LOAD( "galaxian.1k", 0x0800, 0x0800 )
ROM_END



ROM_START( galapx_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "galx.u",  0x0000, 0x0800 )
	ROM_LOAD( "galx.v",  0x0800, 0x0800 )
	ROM_LOAD( "galx.w",  0x1000, 0x0800 )
	ROM_LOAD( "galx.y",  0x1800, 0x0800 )
	ROM_LOAD( "galx.z",  0x2000, 0x0800 )

	ROM_REGION(0x1000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "galx.1h", 0x0000, 0x0800 )
	ROM_LOAD( "galx.1k", 0x0800, 0x0800 )
ROM_END



ROM_START( galap1_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "galx_1.rom",   0x0000, 0x2800 )

	ROM_REGION(0x1000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "galx_1c1.rom", 0x0000, 0x0800 )
	ROM_LOAD( "galx_1c2.rom", 0x0800, 0x0800 )
ROM_END



ROM_START( galap4_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "galx_4.rom",   0x0000, 0x2800 )

	ROM_REGION(0x1000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "galx_4c1.rom", 0x0000, 0x0800 )
	ROM_LOAD( "galx_4c2.rom", 0x0800, 0x0800 )
ROM_END



ROM_START( pisces_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "pisces.a1", 0x0000, 0x0800 )
	ROM_LOAD( "pisces.a2", 0x0800, 0x0800 )
	ROM_LOAD( "pisces.b2", 0x1000, 0x0800 )
	ROM_LOAD( "pisces.c1", 0x1800, 0x0800 )
	ROM_LOAD( "pisces.d1", 0x2000, 0x0800 )
	ROM_LOAD( "pisces.e2", 0x2800, 0x0800 )

	ROM_REGION(0x2000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "pisces.1j", 0x0000, 0x1000 )
	ROM_LOAD( "pisces.1k", 0x1000, 0x1000 )
ROM_END



ROM_START( japirem_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "f07_1a.bin",  0x0000, 0x0800 )
	ROM_LOAD( "h07_2a.bin",  0x0800, 0x0800 )
	ROM_LOAD( "k07_3a.bin",  0x1000, 0x0800 )
	ROM_LOAD( "m07_4a.bin",  0x1800, 0x0800 )
	ROM_LOAD( "d08p_5a.bin", 0x2000, 0x0800 )
	ROM_LOAD( "e08p_6a.bin", 0x2800, 0x0800 )
	ROM_LOAD( "m08p_7a.bin", 0x3000, 0x0800 )
	ROM_LOAD( "n08p_8a.bin", 0x3800, 0x0800 )

	ROM_REGION(0x2000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "k01_1.bin",   0x0000, 0x0800 )
	ROM_LOAD( "k01_2.bin",   0x0800, 0x0800 )
	ROM_LOAD( "h01_1.bin",   0x1000, 0x0800 )
	ROM_LOAD( "h01_2.bin",   0x1800, 0x0800 )
ROM_END



ROM_START( uniwars_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "u1",  0x0000, 0x0800 )
	ROM_LOAD( "u2",  0x0800, 0x0800 )
	ROM_LOAD( "u3",  0x1000, 0x0800 )
	ROM_LOAD( "u4",  0x1800, 0x0800 )
	ROM_LOAD( "u5",  0x2000, 0x0800 )
	ROM_LOAD( "u6",  0x2800, 0x0800 )
	ROM_LOAD( "u7",  0x3000, 0x0800 )
	ROM_LOAD( "u8",  0x3800, 0x0800 )

	ROM_REGION(0x2000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "u9",  0x0000, 0x0800 )
	ROM_LOAD( "u11", 0x0800, 0x0800 )
	ROM_LOAD( "u10", 0x1000, 0x0800 )
	ROM_LOAD( "u12", 0x1800, 0x0800 )
ROM_END



ROM_START( mooncrst_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "mc1", 0x0000, 0x0800 )
	ROM_LOAD( "mc2", 0x0800, 0x0800 )
	ROM_LOAD( "mc3", 0x1000, 0x0800 )
	ROM_LOAD( "mc4", 0x1800, 0x0800 )
	ROM_LOAD( "mc5", 0x2000, 0x0800 )
	ROM_LOAD( "mc6", 0x2800, 0x0800 )
	ROM_LOAD( "mc7", 0x3000, 0x0800 )
	ROM_LOAD( "mc8", 0x3800, 0x0800 )

	ROM_REGION(0x2000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "mca", 0x0000, 0x0800 )
	ROM_LOAD( "mcc", 0x0800, 0x0800 )
	ROM_LOAD( "mcb", 0x1000, 0x0800 )
	ROM_LOAD( "mcd", 0x1800, 0x0800 )
ROM_END



ROM_START( mooncrsb_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "EPR194", 0x0000, 0x0800 )
	ROM_LOAD( "EPR195", 0x0800, 0x0800 )
	ROM_LOAD( "EPR196", 0x1000, 0x0800 )
	ROM_LOAD( "EPR197", 0x1800, 0x0800 )
	ROM_LOAD( "EPR198", 0x2000, 0x0800 )
	ROM_LOAD( "EPR199", 0x2800, 0x0800 )
	ROM_LOAD( "EPR200", 0x3000, 0x0800 )
	ROM_LOAD( "EPR201", 0x3800, 0x0800 )

	ROM_REGION(0x2000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "EPR202", 0x0000, 0x0800 )
	ROM_LOAD( "EPR171", 0x0800, 0x0800 )
	ROM_LOAD( "EPR203", 0x1000, 0x0800 )
	ROM_LOAD( "EPR172", 0x1800, 0x0800 )
ROM_END



ROM_START( moonqsr_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "mq1", 0x0000, 0x0800 )
	ROM_LOAD( "mq2", 0x0800, 0x0800 )
	ROM_LOAD( "mq3", 0x1000, 0x0800 )
	ROM_LOAD( "mq4", 0x1800, 0x0800 )
	ROM_LOAD( "mq5", 0x2000, 0x0800 )
	ROM_LOAD( "mq6", 0x2800, 0x0800 )
	ROM_LOAD( "mq7", 0x3000, 0x0800 )
	ROM_LOAD( "mq8", 0x3800, 0x0800 )

	ROM_REGION(0x2000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "mqa", 0x0000, 0x0800 )
	ROM_LOAD( "mqc", 0x0800, 0x0800 )
	ROM_LOAD( "mqb", 0x1000, 0x0800 )
	ROM_LOAD( "mqd", 0x1800, 0x0800 )
ROM_END



unsigned moonqsr_decode(dword A)
{
	static unsigned char evetab[] =
	{
		0x00,0x01,0x06,0x07,0x40,0x41,0x46,0x47,0x08,0x09,0x0e,0x0f,0x48,0x49,0x4e,0x4f,
		0x10,0x11,0x16,0x17,0x50,0x51,0x56,0x57,0x18,0x19,0x1e,0x1f,0x58,0x59,0x5e,0x5f,
		0x60,0x61,0x66,0x67,0x20,0x21,0x26,0x27,0x68,0x69,0x6e,0x6f,0x28,0x29,0x2e,0x2f,
		0x70,0x71,0x76,0x77,0x30,0x31,0x36,0x37,0x78,0x79,0x7e,0x7f,0x38,0x39,0x3e,0x3f,
		0x04,0x05,0x02,0x03,0x44,0x45,0x42,0x43,0x0c,0x0d,0x0a,0x0b,0x4c,0x4d,0x4a,0x4b,
		0x14,0x15,0x12,0x13,0x54,0x55,0x52,0x53,0x1c,0x1d,0x1a,0x1b,0x5c,0x5d,0x5a,0x5b,
		0x64,0x65,0x62,0x63,0x24,0x25,0x22,0x23,0x6c,0x6d,0x6a,0x6b,0x2c,0x2d,0x2a,0x2b,
		0x74,0x75,0x72,0x73,0x34,0x35,0x32,0x33,0x7c,0x7d,0x7a,0x7b,0x3c,0x3d,0x3a,0x3b,
		0x80,0x81,0x86,0x87,0xc0,0xc1,0xc6,0xc7,0x88,0x89,0x8e,0x8f,0xc8,0xc9,0xce,0xcf,
		0x90,0x91,0x96,0x97,0xd0,0xd1,0xd6,0xd7,0x98,0x99,0x9e,0x9f,0xd8,0xd9,0xde,0xdf,
		0xe0,0xe1,0xe6,0xe7,0xa0,0xa1,0xa6,0xa7,0xe8,0xe9,0xee,0xef,0xa8,0xa9,0xae,0xaf,
		0xf0,0xf1,0xf6,0xf7,0xb0,0xb1,0xb6,0xb7,0xf8,0xf9,0xfe,0xff,0xb8,0xb9,0xbe,0xbf,
		0x84,0x85,0x82,0x83,0xc4,0xc5,0xc2,0xc3,0x8c,0x8d,0x8a,0x8b,0xcc,0xcd,0xca,0xcb,
		0x94,0x95,0x92,0x93,0xd4,0xd5,0xd2,0xd3,0x9c,0x9d,0x9a,0x9b,0xdc,0xdd,0xda,0xdb,
		0xe4,0xe5,0xe2,0xe3,0xa4,0xa5,0xa2,0xa3,0xec,0xed,0xea,0xeb,0xac,0xad,0xaa,0xab,
		0xf4,0xf5,0xf2,0xf3,0xb4,0xb5,0xb2,0xb3,0xfc,0xfd,0xfa,0xfb,0xbc,0xbd,0xba,0xbb
	};
	static unsigned char oddtab[] =
	{
		0x00,0x01,0x42,0x43,0x04,0x05,0x46,0x47,0x08,0x09,0x4a,0x4b,0x0c,0x0d,0x4e,0x4f,
		0x10,0x11,0x52,0x53,0x14,0x15,0x56,0x57,0x18,0x19,0x5a,0x5b,0x1c,0x1d,0x5e,0x5f,
		0x24,0x25,0x66,0x67,0x20,0x21,0x62,0x63,0x2c,0x2d,0x6e,0x6f,0x28,0x29,0x6a,0x6b,
		0x34,0x35,0x76,0x77,0x30,0x31,0x72,0x73,0x3c,0x3d,0x7e,0x7f,0x38,0x39,0x7a,0x7b,
		0x40,0x41,0x02,0x03,0x44,0x45,0x06,0x07,0x48,0x49,0x0a,0x0b,0x4c,0x4d,0x0e,0x0f,
		0x50,0x51,0x12,0x13,0x54,0x55,0x16,0x17,0x58,0x59,0x1a,0x1b,0x5c,0x5d,0x1e,0x1f,
		0x64,0x65,0x26,0x27,0x60,0x61,0x22,0x23,0x6c,0x6d,0x2e,0x2f,0x68,0x69,0x2a,0x2b,
		0x74,0x75,0x36,0x37,0x70,0x71,0x32,0x33,0x7c,0x7d,0x3e,0x3f,0x78,0x79,0x3a,0x3b,
		0x80,0x81,0xc2,0xc3,0x84,0x85,0xc6,0xc7,0x88,0x89,0xca,0xcb,0x8c,0x8d,0xce,0xcf,
		0x90,0x91,0xd2,0xd3,0x94,0x95,0xd6,0xd7,0x98,0x99,0xda,0xdb,0x9c,0x9d,0xde,0xdf,
		0xa4,0xa5,0xe6,0xe7,0xa0,0xa1,0xe2,0xe3,0xac,0xad,0xee,0xef,0xa8,0xa9,0xea,0xeb,
		0xb4,0xb5,0xf6,0xf7,0xb0,0xb1,0xf2,0xf3,0xbc,0xbd,0xfe,0xff,0xb8,0xb9,0xfa,0xfb,
		0xc0,0xc1,0x82,0x83,0xc4,0xc5,0x86,0x87,0xc8,0xc9,0x8a,0x8b,0xcc,0xcd,0x8e,0x8f,
		0xd0,0xd1,0x92,0x93,0xd4,0xd5,0x96,0x97,0xd8,0xd9,0x9a,0x9b,0xdc,0xdd,0x9e,0x9f,
		0xe4,0xe5,0xa6,0xa7,0xe0,0xe1,0xa2,0xa3,0xec,0xed,0xae,0xaf,0xe8,0xe9,0xaa,0xab,
		0xf4,0xf5,0xb6,0xb7,0xf0,0xf1,0xb2,0xb3,0xfc,0xfd,0xbe,0xbf,0xf8,0xf9,0xba,0xbb
	};


	if (A & 1) return oddtab[RAM[A]];
	else return evetab[RAM[A]];
}



ROM_START( theend_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "IC13", 0x0000, 0x0800 )
	ROM_LOAD( "IC14", 0x0800, 0x0800 )
	ROM_LOAD( "IC15", 0x1000, 0x0800 )
	ROM_LOAD( "IC16", 0x1800, 0x0800 )
	ROM_LOAD( "IC17", 0x2000, 0x0800 )
	ROM_LOAD( "IC18", 0x2800, 0x0800 )
	ROM_LOAD( "IC56", 0x3000, 0x0800 )
	ROM_LOAD( "IC55", 0x3800, 0x0800 )

	ROM_REGION(0x1000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "IC30", 0x0000, 0x0800 )
	ROM_LOAD( "IC31", 0x0800, 0x0800 )
ROM_END



ROM_START( scramble_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "2c", 0x0000, 0x0800 )
	ROM_LOAD( "2e", 0x0800, 0x0800 )
	ROM_LOAD( "2f", 0x1000, 0x0800 )
	ROM_LOAD( "2h", 0x1800, 0x0800 )
	ROM_LOAD( "2j", 0x2000, 0x0800 )
	ROM_LOAD( "2l", 0x2800, 0x0800 )
	ROM_LOAD( "2m", 0x3000, 0x0800 )
	ROM_LOAD( "2p", 0x3800, 0x0800 )

	ROM_REGION(0x1000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "5f", 0x0000, 0x0800 )
	ROM_LOAD( "5h", 0x0800, 0x0800 )
ROM_END



ROM_START( atlantis_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "2c", 0x0000, 0x0800 )
	ROM_LOAD( "2e", 0x0800, 0x0800 )
	ROM_LOAD( "2f", 0x1000, 0x0800 )
	ROM_LOAD( "2h", 0x1800, 0x0800 )
	ROM_LOAD( "2j", 0x2000, 0x0800 )
	ROM_LOAD( "2l", 0x2800, 0x0800 )

	ROM_REGION(0x1000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "5f", 0x0000, 0x0800 )
	ROM_LOAD( "5h", 0x0800, 0x0800 )
ROM_END



ROM_START( scobra_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "2c", 0x0000, 0x1000 )
	ROM_LOAD( "2e", 0x1000, 0x1000 )
	ROM_LOAD( "2f", 0x2000, 0x1000 )
	ROM_LOAD( "2h", 0x3000, 0x1000 )
	ROM_LOAD( "2j", 0x4000, 0x1000 )
	ROM_LOAD( "2l", 0x5000, 0x1000 )

	ROM_REGION(0x1000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "5f", 0x0000, 0x0800 )
	ROM_LOAD( "5h", 0x0800, 0x0800 )
ROM_END



ROM_START( scobrab_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "vid_2c.bin",   0x0000, 0x0800 )
	ROM_LOAD( "vid_2e.bin",   0x0800, 0x0800 )
	ROM_LOAD( "vid_2f.bin",   0x1000, 0x0800 )
	ROM_LOAD( "vid_2h.bin",   0x1800, 0x0800 )
	ROM_LOAD( "vid_2j_l.bin", 0x2000, 0x0800 )
	ROM_LOAD( "vid_2l_l.bin", 0x2800, 0x0800 )
	ROM_LOAD( "vid_2m_l.bin", 0x3000, 0x0800 )
	ROM_LOAD( "vid_2p_l.bin", 0x3800, 0x0800 )
	ROM_LOAD( "vid_2j_u.bin", 0x4000, 0x0800 )
	ROM_LOAD( "vid_2l_u.bin", 0x4800, 0x0800 )
	ROM_LOAD( "vid_2m_u.bin", 0x5000, 0x0800 )
	ROM_LOAD( "vid_2p_u.bin", 0x5800, 0x0800 )

	ROM_REGION(0x1000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "vid_5f.bin",   0x0000, 0x0800 )
	ROM_LOAD( "vid_5h.bin",   0x0800, 0x0800 )
ROM_END



ROM_START( frogger_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "frogger.ic5", 0x0000, 0x1000 )
	ROM_LOAD( "frogger.ic6", 0x1000, 0x1000 )
	ROM_LOAD( "frogger.ic7", 0x2000, 0x1000 )
	ROM_LOAD( "frogger.ic8", 0x3000, 0x1000 )

	ROM_REGION(0x1000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "frogger.606", 0x0000, 0x0800 )
	ROM_LOAD( "frogger.607", 0x0800, 0x0800 )
ROM_END



ROM_START( froggers_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "vid_d2.bin", 0x0000, 0x0800 )
	ROM_LOAD( "vid_e2.bin", 0x0800, 0x0800 )
	ROM_LOAD( "vid_f2.bin", 0x1000, 0x0800 )
	ROM_LOAD( "vid_h2.bin", 0x1800, 0x0800 )
	ROM_LOAD( "vid_j2.bin", 0x2000, 0x0800 )
	ROM_LOAD( "vid_l2.bin", 0x2800, 0x0800 )

	ROM_REGION(0x1000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "vid_f5.bin", 0x0000, 0x0800 )
	ROM_LOAD( "vid_h5.bin", 0x0800, 0x0800 )
ROM_END



ROM_START( amidar_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "%s.2c", 0x0000, 0x1000 )
	ROM_LOAD( "%s.2e", 0x1000, 0x1000 )
	ROM_LOAD( "%s.2f", 0x2000, 0x1000 )
	ROM_LOAD( "%s.2h", 0x3000, 0x1000 )

	ROM_REGION(0x1000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "%s.5f", 0x0000, 0x0800 )
	ROM_LOAD( "%s.5h", 0x0800, 0x0800 )
ROM_END



ROM_START( amidarus_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "%s.2c", 0x0000, 0x1000 )
	ROM_LOAD( "%s.2e", 0x1000, 0x1000 )
	ROM_LOAD( "%s.2f", 0x2000, 0x1000 )
	ROM_LOAD( "%s.2h", 0x3000, 0x1000 )
	ROM_LOAD( "%s.2j", 0x4000, 0x1000 )

	ROM_REGION(0x1000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "%s.5f", 0x0000, 0x0800 )
	ROM_LOAD( "%s.5h", 0x0800, 0x0800 )
ROM_END



ROM_START( turtles_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "turt_vid.2c", 0x0000, 0x1000 )
	ROM_LOAD( "turt_vid.2e", 0x1000, 0x1000 )
	ROM_LOAD( "turt_vid.2f", 0x2000, 0x1000 )
	ROM_LOAD( "turt_vid.2h", 0x3000, 0x1000 )
	ROM_LOAD( "turt_vid.2j", 0x4000, 0x1000 )

	ROM_REGION(0x1000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "turt_vid.5f", 0x0000, 0x0800 )
	ROM_LOAD( "turt_vid.5h", 0x0800, 0x0800 )
ROM_END



ROM_START( rallyx_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "%s.1b", 0x0000, 0x1000 )
	ROM_LOAD( "%s.1e", 0x1000, 0x1000 )
	ROM_LOAD( "%s.1h", 0x2000, 0x1000 )
	ROM_LOAD( "%s.1k", 0x3000, 0x1000 )

	ROM_REGION(0x1000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "%s.8e", 0x0000, 0x1000 )
ROM_END



ROM_START( pooyan_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "ic22_a4.cpu",  0x0000, 0x2000 )
	ROM_LOAD( "ic23_a5.cpu",  0x2000, 0x2000 )
	ROM_LOAD( "ic24_a6.cpu",  0x4000, 0x2000 )
	ROM_LOAD( "ic25_a7.cpu",  0x6000, 0x2000 )

	ROM_REGION(0x4000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "ic14_g9.cpu",  0x0000, 0x1000 )
	ROM_LOAD( "ic13_g10.cpu", 0x1000, 0x1000 )
	ROM_LOAD( "ic15_a9.cpu",  0x2000, 0x1000 )
	ROM_LOAD( "ic16_a8.cpu",  0x3000, 0x1000 )
ROM_END



ROM_START( phoenix_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD("phoenix.45", 0x0000, 0x0800)
	ROM_LOAD("phoenix.46", 0x0800, 0x0800)
	ROM_LOAD("phoenix.47", 0x1000, 0x0800)
	ROM_LOAD("phoenix.48", 0x1800, 0x0800)
	ROM_LOAD("phoenix.49", 0x000, 0x0800)
	ROM_LOAD("phoenix.50", 0x2800, 0x0800)
	ROM_LOAD("phoenix.51", 0x3000, 0x0800)
	ROM_LOAD("phoenix.52", 0x3800, 0x0800)

	ROM_REGION(0x2000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD("phoenix.39", 0x0000, 0x0800)
	ROM_LOAD("phoenix.40", 0x0800, 0x0800)
	ROM_LOAD("phoenix.23", 0x1000, 0x0800)
	ROM_LOAD("phoenix.24", 0x1800, 0x0800)
ROM_END



ROM_START( pleiades_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "pleiades.47", 0x0000, 0x0800)
	ROM_LOAD( "pleiades.48", 0x0800, 0x0800)
	ROM_LOAD( "pleiades.49", 0x1000, 0x0800)
	ROM_LOAD( "pleiades.50", 0x1800, 0x0800)
	ROM_LOAD( "pleiades.51", 0x2000, 0x0800)
	ROM_LOAD( "pleiades.52", 0x2800, 0x0800)
	ROM_LOAD( "pleiades.53", 0x3000, 0x0800)
	ROM_LOAD( "pleiades.54", 0x3800, 0x0800)

	ROM_REGION(0x2000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "pleiades.27", 0x0000, 0x0800)
	ROM_LOAD( "pleiades.26", 0x0800, 0x0800)
	ROM_LOAD( "pleiades.45", 0x1000, 0x0800)
	ROM_LOAD( "pleiades.44", 0x1800, 0x0800)
ROM_END



ROM_START( carnival_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "651u33.cpu", 0x0000, 0x0400 )
	ROM_CONTINUE(           0x4000, 0x0400 )
	ROM_LOAD( "652u32.cpu", 0x0400, 0x0400 )
	ROM_CONTINUE(           0x4400, 0x0400 )
	ROM_LOAD( "653u31.cpu", 0x0800, 0x0400 )
	ROM_CONTINUE(           0x4800, 0x0400 )
	ROM_LOAD( "654u30.cpu", 0x0c00, 0x0400 )
	ROM_CONTINUE(           0x4c00, 0x0400 )
	ROM_LOAD( "655u29.cpu", 0x1000, 0x0400 )
	ROM_CONTINUE(           0x5000, 0x0400 )
	ROM_LOAD( "656u28.cpu", 0x1400, 0x0400 )
	ROM_CONTINUE(           0x5400, 0x0400 )
	ROM_LOAD( "657u27.cpu", 0x1800, 0x0400 )
	ROM_CONTINUE(           0x5800, 0x0400 )
	ROM_LOAD( "658u26.cpu", 0x1c00, 0x0400 )
	ROM_CONTINUE(           0x5c00, 0x0400 )
	ROM_LOAD( "659u8.cpu",  0x2000, 0x0400 )
	ROM_CONTINUE(           0x6000, 0x0400 )
	ROM_LOAD( "660u7.cpu",  0x2400, 0x0400 )
	ROM_CONTINUE(           0x6400, 0x0400 )
	ROM_LOAD( "661u6.cpu",  0x2800, 0x0400 )
	ROM_CONTINUE(           0x6800, 0x0400 )
	ROM_LOAD( "662u5.cpu",  0x2c00, 0x0400 )
	ROM_CONTINUE(           0x6c00, 0x0400 )
	ROM_LOAD( "663u4.cpu",  0x3000, 0x0400 )
	ROM_CONTINUE(           0x7000, 0x0400 )
	ROM_LOAD( "664u3.cpu",  0x3400, 0x0400 )
	ROM_CONTINUE(           0x7400, 0x0400 )
	ROM_LOAD( "665u2.cpu",  0x3800, 0x0400 )
	ROM_CONTINUE(           0x7800, 0x0400 )
	ROM_LOAD( "666u1.cpu",  0x3c00, 0x0400 )
	ROM_CONTINUE(           0x7c00, 0x0400 )
ROM_END



ROM_START( invaders_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "invaders.h", 0x0000, 0x0800)
	ROM_LOAD( "invaders.g", 0x0800, 0x0800)
	ROM_LOAD( "invaders.f", 0x1000, 0x0800)
	ROM_LOAD( "invaders.e", 0x1800, 0x0800)
ROM_END



ROM_START( spaceatt_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "spaceatt.h", 0x0000, 0x0800)
	ROM_LOAD( "spaceatt.g", 0x0800, 0x0800)
	ROM_LOAD( "spaceatt.f", 0x1000, 0x0800)
	ROM_LOAD( "spaceatt.e", 0x1800, 0x0800)
ROM_END



ROM_START( invdelux_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "invdelux.h", 0x0000, 0x0800)
	ROM_LOAD( "invdelux.g", 0x0800, 0x0800)
	ROM_LOAD( "invdelux.f", 0x1000, 0x0800)
	ROM_LOAD( "invdelux.e", 0x1800, 0x0800)
	ROM_LOAD( "invdelux.d", 0x4000, 0x0800)
ROM_END



ROM_START( galxwars_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "galxwars.0", 0x0000, 0x0400)
	ROM_LOAD( "galxwars.1", 0x0400, 0x0400)
	ROM_LOAD( "galxwars.2", 0x0800, 0x0400)
	ROM_LOAD( "galxwars.3", 0x0c00, 0x0400)
	ROM_LOAD( "galxwars.4", 0x4000, 0x0400)
	ROM_LOAD( "galxwars.5", 0x4400, 0x0400)
ROM_END



ROM_START( lrescue_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "lrescue.1", 0x0000, 0x0800)
	ROM_LOAD( "lrescue.2", 0x0800, 0x0800)
	ROM_LOAD( "lrescue.3", 0x1000, 0x0800)
	ROM_LOAD( "lrescue.4", 0x1800, 0x0800)
	ROM_LOAD( "lrescue.5", 0x4000, 0x0800)
	ROM_LOAD( "lrescue.6", 0x4800, 0x0800)
ROM_END



ROM_START( desterth_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "36_h.bin", 0x0000, 0x0800)
	ROM_LOAD( "35_g.bin", 0x0800, 0x0800)
	ROM_LOAD( "34_f.bin", 0x1000, 0x0800)
	ROM_LOAD( "33_e.bin", 0x1800, 0x0800)
	ROM_LOAD( "32_d.bin", 0x4000, 0x0800)
	ROM_LOAD( "31_c.bin", 0x4800, 0x0800)
	ROM_LOAD( "42_b.bin", 0x5000, 0x0800)
ROM_END



ROM_START( mario_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "%s.7f", 0x0000, 0x2000 )
	ROM_LOAD( "%s.7e", 0x2000, 0x2000 )
	ROM_LOAD( "%s.7d", 0x4000, 0x2000 )
	ROM_LOAD( "%s.7c", 0xf000, 0x1000 )

	ROM_REGION(0x8000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "%s.3f", 0x0000, 0x1000 )
	ROM_LOAD( "%s.3j", 0x1000, 0x1000 )
	ROM_LOAD( "%s.7m", 0x2000, 0x1000 )
	ROM_LOAD( "%s.7n", 0x3000, 0x1000 )
	ROM_LOAD( "%s.7p", 0x4000, 0x1000 )
	ROM_LOAD( "%s.7s", 0x5000, 0x1000 )
	ROM_LOAD( "%s.7t", 0x6000, 0x1000 )
	ROM_LOAD( "%s.7u", 0x7000, 0x1000 )

	ROM_REGION(0x1000)	/* sound? */
	ROM_LOAD( "%s.6k", 0x0000, 0x1000 )
ROM_END



ROM_START( zaxxon_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "%s.3",  0x0000, 0x2000 )
	ROM_LOAD( "%s.2",  0x2000, 0x2000 )
	ROM_LOAD( "%s.1",  0x4000, 0x1000 )

	ROM_REGION(0xd000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "%s.15", 0x0000, 0x0800 )
	ROM_LOAD( "%s.14", 0x0800, 0x0800 )
	ROM_LOAD( "%s.13", 0x1000, 0x2000 )
	ROM_LOAD( "%s.12", 0x3000, 0x2000 )
	ROM_LOAD( "%s.11", 0x5000, 0x2000 )
	ROM_LOAD( "%s.6",  0x7000, 0x2000 )
	ROM_LOAD( "%s.5",  0x9000, 0x2000 )
	ROM_LOAD( "%s.4",  0xb000, 0x2000 )

	ROM_REGION(0x8000)	/* background graphics */
	ROM_LOAD( "%s.8",  0x0000, 0x2000 )
	ROM_LOAD( "%s.7",  0x2000, 0x2000 )
	ROM_LOAD( "%s.10", 0x4000, 0x2000 )
	ROM_LOAD( "%s.9",  0x6000, 0x2000 )
ROM_END



ROM_START( bombjack_rom )
	ROM_REGION(0x10000)	/* 64k for code */
	ROM_LOAD( "09_j01b.bin",  0x0000, 0x2000 )
	ROM_LOAD( "10_l01b.bin",  0x2000, 0x2000 )
	ROM_LOAD( "11_m01b.bin",  0x4000, 0x2000 )
	ROM_LOAD( "12_n01b.bin",  0x6000, 0x2000 )
	ROM_LOAD( "13_r01b.bin",  0xc000, 0x2000 )

	ROM_REGION(0xf000)	/* temporary space for graphics (disposed after conversion) */
	ROM_LOAD( "03_e08t.bin",  0x0000, 0x1000 )	/* chars */
	ROM_LOAD( "04_h08t.bin",  0x1000, 0x1000 )
	ROM_LOAD( "05_k08t.bin",  0x2000, 0x1000 )
	ROM_LOAD( "06_l08t.bin",  0x3000, 0x2000 )	/* background tiles */
	ROM_LOAD( "07_n08t.bin",  0x5000, 0x2000 )
	ROM_LOAD( "08_r08t.bin",  0x7000, 0x2000 )
	ROM_LOAD( "16_m07b.bin",  0x9000, 0x2000 )	/* sprites */
	ROM_LOAD( "15_l07b.bin",  0xb000, 0x2000 )
	ROM_LOAD( "14_j07b.bin",  0xd000, 0x2000 )

	ROM_REGION(0x1000)	/* background graphics */
	ROM_LOAD( "02_p04t.bin",  0x0000, 0x1000 )

	ROM_REGION(0x10000)	/* 64 for sound board */
	ROM_LOAD( "01_h03t.bin",  0x0000, 0x2000 )
ROM_END



struct GameDriver drivers[] =
{
	{ "pacman",   pacman_rom,   0, 0,               &pacman_driver },
	{ "pacmod",   pacmod_rom,   0, 0,               &pacman_driver },
	{ "namcopac", pacman_rom,   0, 0,               &pacman_driver },
	{ "hangly",   pacman_rom,   0, 0,               &pacman_driver },
	{ "puckman",  pacman_rom,   0, 0,               &pacman_driver },
	{ "piranha",  piranha_rom,  0, 0,               &pacman_driver },
	{ "mspacman", mspacman_rom, 0, 0,               &mspacman_driver },
	{ "crush",    crush_rom,    0, 0,               &crush_driver },
	{ "pengo",    pengo_rom,    0, 0,               &pengo_driver },
	{ "penta",    penta_rom,    0, 0,               &pengo_driver },
	{ "ladybug",  ladybug_rom,  0, 0,               &ladybug_driver },
	{ "mrdo",     mrdo_rom,     0, 0,               &mrdo_driver },
	{ "mrlo",     mrlo_rom,     0, 0,               &mrdo_driver },
	{ "cclimber", cclimber_rom, 0, cclimber_decode, &cclimber_driver },
	{ "ccjap",    ccjap_rom,    0, ccjap_decode,    &cclimber_driver },
	{ "ccboot",   ccboot_rom,   0, ccjap_decode,    &cclimber_driver },
	{ "ckong",    ckong_rom,    0, 0,               &ckong_driver },
	{ "dkong",    dkong_rom,    0, 0,               &dkong_driver },
	{ "dkongjr",  dkongjr_rom,  0, 0,               &dkongjr_driver },
	{ "bagman",   bagman_rom,   0, 0,               &bagman_driver },
	{ "wow",      wow_rom,      0, 0,               &wow_driver },
	{ "robby",    robby_rom,    0, 0,               &wow_driver },
	{ "gorf",     gorf_rom,     0, 0,               &wow_driver },
	{ "galaxian", galaxian_rom, 0, 0,               &galaxian_driver },
	{ "galnamco", galnamco_rom, 0, 0,               &galaxian_driver },
	{ "superg",   galnamco_rom, 0, 0,               &galaxian_driver },
	{ "galapx",   galapx_rom,   0, 0,               &galaxian_driver },
	{ "galap1",   galap1_rom,   0, 0,               &galaxian_driver },
	{ "galap4",   galap4_rom,   0, 0,               &galaxian_driver },
	{ "galturbo", galnamco_rom, 0, 0,               &galaxian_driver },
	{ "pisces",   pisces_rom,   0, 0,               &pisces_driver },
	{ "japirem",  japirem_rom,  0, 0,               &japirem_driver },
	{ "uniwars",  uniwars_rom,  0, 0,               &japirem_driver },
	{ "warofbug", galaxian_rom, 0, 0,               &warofbug_driver },
	{ "mooncrst", mooncrst_rom, moonqsr_decode, 0,  &mooncrst_driver },
	{ "mooncrsb", mooncrsb_rom, 0, 0,               &mooncrst_driver },
	{ "moonqsr",  moonqsr_rom,  0, moonqsr_decode,  &moonqsr_driver },
	{ "theend",   theend_rom,   0, 0,               &theend_driver },
	{ "scramble", scramble_rom, 0, 0,               &scramble_driver },
	{ "atlantis", atlantis_rom, 0, 0,               &atlantis_driver },
	{ "scobra",   scobra_rom,   0, 0,               &scobra_driver },
	{ "scobrab",  scobrab_rom,  0, 0,               &scobra_driver },
	{ "frogger",  frogger_rom,  0, 0,               &frogger_driver },
	{ "froggers", froggers_rom, 0, 0,               &scramble_driver },
	{ "amidar",   amidar_rom,   0, 0,               &amidar_driver },
	{ "amidarus", amidarus_rom, 0, 0,               &amidar_driver },
	{ "turtles",  turtles_rom,  0, 0,               &turtles_driver },
	{ "rallyx",   rallyx_rom,   0, 0,               &rallyx_driver },
	{ "pooyan",   pooyan_rom,   0, 0,               &pooyan_driver },
	{ "phoenix",  phoenix_rom,  0, 0,               &phoenix_driver },
	{ "pleiades", pleiades_rom, 0, 0,               &phoenix_driver },
	{ "carnival", carnival_rom, 0, 0,               &carnival_driver },
	{ "invaders", invaders_rom, 0, 0,               &invaders_driver },
	{ "earthinv", invaders_rom, 0, 0,               &invaders_driver },
	{ "spaceatt", spaceatt_rom, 0, 0,               &invaders_driver },
	{ "invdelux", invdelux_rom, 0, 0,               &invaders_driver },
	{ "galxwars", galxwars_rom, 0, 0,               &invaders_driver },
	{ "lrescue",  lrescue_rom,  0, 0,               &invaders_driver },
	{ "desterth", desterth_rom, 0, 0,               &invaders_driver },
	{ "mario",    mario_rom,    0, 0,               &mario_driver },
	{ "zaxxon",   zaxxon_rom,   0, 0,               &zaxxon_driver },
	{ "bombjack", bombjack_rom, 0, 0,               &bombjack_driver },
	{ 0	}	/* end of array */
};
